/*
  +----------------------------------------------------------------------+
  | Portable System Library                                              |
  | Author: Sukchan Lee (acetcom@postech.ac.kr)                          |
  +----------------------------------------------------------------------+

  $Id: psys.c 113 2004-04-06 06:02:40Z acetcom $
*/

#include "psys/common.h"
#include "psys/memory.h"
#include "psys/errno.h"

psys_status_t psys_mem_pool_initialize(void);
void psys_mem_pool_terminate(void);

static psys_status_t psys_initialized = 0;

psys_status_t psys_initialize(void)
{
    psys_status_t rv;

    if (psys_initialized)
    {
        return PSYS_SUCCESS;
    }

    if ((rv = psys_mem_pool_initialize()) != PSYS_SUCCESS)
    {
        return rv;
    }

    psys_initialized++;

    return PSYS_SUCCESS;
}

void psys_terminate(void)
{
    if (!psys_initialized)
    {
        return;
    }

    psys_mem_pool_terminate();

    --psys_initialized;
}
